"use strict";

exports.__esModule = true;
exports.mount = exports.batch = void 0;
var _react = _interopRequireDefault(require("react"));
var _client = require("react-dom/client");
var _reactDom = require("react-dom");
var _warning = require("./warning");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
// from https://github.com/purposeindustries/window-or-global/blob/master/lib/index.js
// avoid direct usage of 'window' because `window is not defined` error might happen in babel-node
var globalObject = typeof self === 'object' && self.self === self && self || typeof global === 'object' && global.global === global && global || void 0;
var batch = function batch(cb) {
  return (0, _reactDom.unstable_batchedUpdates)(cb);
};
exports.batch = batch;
var mount = function mount(C) {
  if (globalObject.document && globalObject.document.createElement) {
    var container = globalObject.document.createElement('div');
    var root = (0, _client.createRoot)(container);
    root.render( /*#__PURE__*/_react["default"].createElement(C, {
      automaticContainerInternalUseOnly: true
    }));
  } else {
    (0, _warning.warning)('Can not mount SingletonHooksContainer on server side. ' + 'Did you manage to run useEffect on server? ' + 'Please mount SingletonHooksContainer into your components tree manually.');
  }
};
exports.mount = mount;